// Header file bmp.h
// Faan Tone Liu
// 3/29/03
// Format information for .bmp files to be used on SUN workstations
// This is NOT portable to PCs!
// Format information from http://members.fortunecity.com/shetzl/bmpffrmt.html

#ifndef _BMP_H
#define _BMP_H
#include <string>
using std::string;

// bitmap file header
struct bmfh_struct {
    char bfType[2];     // Must contains the characters 'BM'
    int bfSize;         // size of file in bytes
    short bfReserved1;  // sizeof(short) MUST be 2 bytes
    short bfReserved2;  // Set both bfreserved to 0
    int bfOffBits;      // offset from start of file to bitmap data
};

// bitmap info header
struct bmih_struct {
    int biSize;        // Size of info header - should be 40 bytes
    int biWidth;       // Width of image in pixels
    int biHeight;      // Height of image in pixels
    short biPlanes;    // Number of planes in target device - set to 0
    short biBitCount;  // Bits per pixel
    int biCompression; // Compression type - 0 for our use
    int biSizeImage;   // Image data size in bytes - set to 0 if no compression
    int biXPelsPerMeter;   // Horizontal pixels per meter - set to 0 for default
    int biYPelsPerMeter;   // Vertical pixels per meter - set to 0 for default
    int biClrUsed;         // # of colors in bitmap - 0 to calc from biBitCount
    int biClrImportant;    // # of important colors - 0 for all colors important
};

#define BMF_DEFAULT_TYPE "BM"    // identifies as bitmap file
#define BMF_DEFAULT_SIZE 14      // size of file header
#define BMIH_DEFAULT_SIZE 40     // Size of Info header

bool write_bitmap_file(string fn, int width, int height, unsigned char*data);
unsigned char * read_bitmap_file(string fn, int &width, int &height);
#endif
